Attribute VB_Name = "modBMSLoad"
Option Explicit

Private Type m_udtObj
    blnFlag     As Boolean
    intChannel  As Integer
    intMeasure  As Integer
    sngPosition As Single
    lngHeight   As Long
    sngValue    As Single
End Type

Public g_Obj()  As m_udtObj

Private Type m_udtMeasure
    sngLen  As Single
    sngPos  As Single
End Type

Public g_Measure()  As m_udtMeasure

Public g_MeasureLine(999)   As m_udtObj

Private m_sngBPMBuffer(1295)    As Single
Private m_lngStopBuffer(1295)   As Long
Public g_intWAVBuffer(1295)     As Integer
Public g_intBGABuffer(1295)     As Integer

Private m_intWAVFileNum As Integer
Private m_intBGAFileNum As Integer

Private Type RECT
    X1  As Long
    Y1  As Long
    X2  As Long
    Y2  As Long
End Type

Private Type m_udtExBGA
    intNum  As Integer
    RECT    As RECT
    x       As Integer
    y       As Integer
End Type

Public g_ExBGABuffer(1295)  As m_udtExBGA


Public Sub LoadBMS()
On Error GoTo Err:
    
    With g_BMS
        .intPlayerType = 1
        .strGenre = ""
        .strTitle = ""
        .strArtist = ""
        .sngBPM = 120
        .lngPlayLevel = 0
        .intRank = 0
        .lngTotalNotes = 0
        .intEndMeasure = 0
        .sngPhaseTime = 0
        .strRandom = ""
    End With
    
    ReDim g_Obj(0)
    ReDim g_Measure(999)
    
    ReDim m_Random(0)
    With m_Random(0)
        .blnReadFlag = True
        .lngNum = 0
        .lngMax = 0
        .lngReadNum = 0
    End With
    
    Call LoadBMSData
    
    Call LoadBMSSort
    
    If g_BMS.strGenre <> "" Then
        g_strBMSTitle = "[" & g_BMS.strGenre & "] "
    Else
        g_strBMSTitle = "/ "
    End If
    If g_BMS.strTitle <> "" Then
        g_strBMSTitle = g_strBMSTitle & g_BMS.strTitle & " / "
    Else
        g_strBMSTitle = g_strBMSTitle & "No Title / "
    End If
    If g_BMS.strArtist <> "" Then
        g_strBMSTitle = g_strBMSTitle & g_BMS.strArtist & " "
    Else
        g_strBMSTitle = g_strBMSTitle & "Unknown Artist "
    End If
    frmMain.Caption = g_strTitle & " [" & g_BMS.intStartMeasure & "/" & g_BMS.intEndMeasure + g_BMS.intStartMeasure & "] " & g_strBMSTitle
    
    g_intBGANum = 0
    g_intLayerNum = 0
    g_BMS.sngPhaseTime = 6000000 / (g_BMS.sngBPM * g_PlayOption.intRealSpeed * 48 * g_PlayOption.intDefaultPhase)
    g_sngPlayCounter = 0
    g_lngPlayLastTime = timeGetTime()
    g_lngPauseTime = 0
    g_lngBottomObj = 0
    g_intBottomMeasure = 0
    If g_PlayOption.blnAlwaysOnTop = False Then
        Call SetWindowPos(frmMain.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWNOSIZE Or SWNOMOVE Or SWSHOWWINDOW)
        Call SetWindowPos(frmMain.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWNOSIZE Or SWNOMOVE Or SWSHOWWINDOW)
    End If
    frmMain.Show
    g_lngPlayStartTime = timeGetTime()
    
    Exit Sub

Err:
    Call CleanUp(Err.Number, Err.Description, "LoadBMS")
End Sub

Private Sub LoadBMSData()
On Error GoTo Err:

    Dim i           As Long
    Dim strArray()  As String
    Dim strRet      As String
    Dim lngFFile    As Long
    
    For i = 0 To 999
        g_Measure(i).sngLen = 192 * g_PlayOption.intDefaultPhase
        g_MeasureLine(i).sngPosition = g_Measure(i).sngLen * i
        g_MeasureLine(i).lngHeight = g_MeasureLine(i).sngPosition
    Next i
    For i = 0 To 1295
        g_intWAVBuffer(i) = 0
        g_intBGABuffer(i) = 0
        g_ExBGABuffer(i).intNum = 0
    Next i
    For i = 0 To 255
        m_sngBPMBuffer(i) = 0
        m_lngStopBuffer(i) = 0
    Next i
    
    m_intWAVFileNum = 0
    m_intBGAFileNum = 0
    
    lngFFile = FreeFile()
    
    Open g_BMS.strDir & g_BMS.strFileName For Input As #lngFFile
    
        Do While Not EOF(lngFFile)
        
            DoEvents
            
            If g_intGameMode = 1 Then Exit Sub
            
            Call LoadingTitle
            
            Line Input #lngFFile, strRet
            
            strRet = Trim$(strRet)
            strArray = Split(strRet, Chr$(10))
            
            For i = 0 To UBound(strArray)
            
                If Left$(strArray(i), 1) = "#" Then Call LoadBMSDataSub(strArray(i))
            
            Next i
        
        Loop
    
    Close #lngFFile
    
    If UBound(g_Obj) > 0 Then ReDim Preserve g_Obj(UBound(g_Obj) - 1)
    
    ReDim Preserve g_sndWAV(m_intWAVFileNum)
    ReDim Preserve g_picBGA(m_intBGAFileNum)
    
    Exit Sub

Err:
    Call CleanUp(Err.Number, Err.Description, "LoadBMSData")
End Sub

Private Sub LoadBMSDataSub(ByVal strLineData As String)

    Dim strArray()  As String
    Dim strParam    As String
    
    strLineData = Replace(strLineData, " ", ":", 1, 1) 'code : Desert΍
    strArray() = Split(strLineData, ":")
    
    If UBound(strArray) > 0 Then
    
        strParam = Right$(strLineData, Len(strLineData) - (Len(strArray(0)) + 1))
        
        Select Case UCase$(strArray(0))
            Case "#PATH_WAV": g_BMS.strDir = strParam
            Case "#PLAYER": g_BMS.intPlayerType = Val(strParam)
            Case "#GENRE": g_BMS.strGenre = strParam
            Case "#TITLE": g_BMS.strTitle = strParam
            Case "#ARTIST": g_BMS.strArtist = strParam
            Case "#BPM": g_BMS.sngBPM = Val(strParam)
            Case "#PLAYLEVEL": g_BMS.lngPlayLevel = Val(strParam)
            Case "#STAGEFILE": 'Ȃ
            Case "#RANK"
                g_BMS.intRank = Val(strParam) + 1
                If g_BMS.intRank < 1 Then g_BMS.intRank = 1
                If g_BMS.intRank > 4 Then g_BMS.intRank = 4
            Case "#RANDOM"
                Call Randomize
                If m_Random(0).blnReadFlag = True Then
                    Call RandomCreate(0, Rnd * Val(strParam) + 1, True, Val(strParam), 0)
                    g_BMS.strRandom = g_BMS.strRandom & ">" & m_Random(0).lngReadNum & "/" & Val(strParam) + 1
                Else
                    Call RandomCreate(0, 0, False, Val(strParam), 0)
                End If
            Case "#IF"
                m_Random(0).lngNum = m_Random(0).lngNum + 1
                If Val(strParam) <> m_Random(0).lngReadNum Then
                    m_Random(0).blnReadFlag = False
                End If
            Case Else
                If Right$(strArray(0), 2) <> "00" Then
                    Select Case UCase$(Left$(strArray(0), 4))
                        Case "#WAV"
                            m_intWAVFileNum = m_intWAVFileNum + 1
                            Call CreateWAVBuffer(g_BMS.strDir & Right$(strLineData, Len(strLineData) - 7), m_intWAVFileNum)
                            If g_sndWAV(m_intWAVFileNum).blnLoadFlag <> True Then 'Ȃ񂩓ǂݍ߂ȂH
                                strArray = Split(strLineData, ".")
                                If UCase$(strArray(UBound(strArray))) = "WAV" Then 'MP3Ȃ
                                    Call CreateWAVBuffer(g_BMS.strDir & Mid$(strLineData, 8, Len(strLineData) - 7 - Len(strArray(UBound(strArray)))) & "mp3", m_intWAVFileNum)
                                ElseIf UCase$(strArray(UBound(strArray))) = "MP3" Then 'WAVȂ
                                    Call CreateWAVBuffer(g_BMS.strDir & Mid$(strLineData, 8, Len(strLineData) - 7 - Len(strArray(UBound(strArray)))) & "wav", m_intWAVFileNum)
                                Else 'WAVMP3H(ǂ)
                                    Call CreateWAVBuffer(g_BMS.strDir & Mid$(strLineData, 8, Len(strLineData) - 7 - Len(strArray(UBound(strArray)))) & "wav", m_intWAVFileNum)
                                    If g_sndWAV(m_intWAVFileNum).blnLoadFlag <> True Then Call CreateWAVBuffer(g_BMS.strDir & Mid$(strLineData, 8, Len(strLineData) - 7 - Len(strArray(UBound(strArray)))) & "mp3", m_intWAVFileNum)
                                End If
                            End If
                            g_intWAVBuffer(lngNumConv(Mid$(strLineData, 5, 2))) = m_intWAVFileNum
                        Case "#BMP"
                            If g_PlayOption.blnDispBGA = True Then
                                m_intBGAFileNum = m_intBGAFileNum + 1
                                Call CreateBGABuffer(g_BMS.strDir + Right$(strLineData, Len(strLineData) - 7), m_intBGAFileNum)
                                g_intBGABuffer(lngNumConv(Mid$(strLineData, 5, 2))) = m_intBGAFileNum
                            End If
                        Case "#BPM"
                            m_sngBPMBuffer(lngNumConv(Mid$(strLineData, 5, 2))) = Mid$(strLineData, 8)
                        Case "#BGA"
                            strArray() = Split(strParam, " ")
                            With g_ExBGABuffer(lngNumConv(Mid$(strLineData, 5, 2)))
                                .intNum = strArray(0)
                                .RECT.Top = strArray(2)
                                .RECT.Left = strArray(1)
                                .RECT.Right = strArray(3)
                                .RECT.Bottom = strArray(4)
                                .x = strArray(5)
                                .y = strArray(6)
                            End With
                        Case Else
                            If Left$(UCase$(strArray(0)), 5) = "#STOP" Then
                                m_lngStopBuffer(lngNumConv(Mid$(strLineData, 6, 2))) = Mid$(strLineData, 9)
                            Else 'ʃIuWF
                                If m_Random(0).blnReadFlag = True Then
                                    Call LoadBMSObject(strLineData)
                                End If
                            End If
                    End Select
                End If
        End Select
    
    ElseIf UCase$(Left$(strLineData, 6)) = "#ENDIF" Then
    
        If m_Random(0).lngNum >= m_Random(0).lngMax Then
            Call RandomDelete(0)
        End If
        m_Random(0).blnReadFlag = True
    
    End If

End Sub

Private Sub LoadBMSSort()
On Error GoTo Err:

    Dim i   As Long
    Dim j   As Long
    Dim d   As Long
    
    For i = 1 To 999
        d = d + g_Measure(i - 1).sngLen
        g_Measure(i).sngPos = d
        g_MeasureLine(i - 1).sngPosition = d
        g_MeasureLine(i - 1).lngHeight = d
        g_MeasureLine(i - 1).blnFlag = True
    Next
    
    For i = 0 To UBound(g_Obj)
    
        With g_Obj(i)
            If (.intChannel >= 11 Or .intChannel = 1 Or .intChannel = 4 Or .intChannel = 5) And g_BMS.intEndMeasure < .intMeasure Then
                g_BMS.intEndMeasure = .intMeasure
            End If
            .sngPosition = g_Measure(.intMeasure).sngPos + ((g_Measure(.intMeasure).sngLen / .lngHeight) * .sngPosition)
            .lngHeight = .sngPosition
            If .intChannel = 9 Then 'gBPM
                If m_sngBPMBuffer(.sngValue) = 0 Then
                    .intChannel = 0
                Else
                    .sngValue = m_sngBPMBuffer(.sngValue)
                    .intChannel = 2
                End If
            ElseIf .intChannel = 3 Then 'XgbvV[PX
                .sngValue = m_lngStopBuffer(.sngValue)
            End If
        End With
        Call LoadingTitle
    
    Next i
    
    ReDim Preserve g_Measure(g_BMS.intEndMeasure)
    
    frmMain.Caption = frmMain.Caption & ""
    
    Call QuickSort(0, UBound(g_Obj))
    
    For i = 0 To UBound(g_Obj)
    
        With g_Obj(i)
        
            If .intChannel >= 31 And .intChannel <= 48 Then 'Om[gJn
            
                For j = i - 1 To 0 Step -1
                
                    If .sngPosition <> g_Obj(j).sngPosition Then
                        Exit For
                    ElseIf g_Obj(j).intChannel - 10 = .intChannel - 30 And .sngPosition = g_Obj(j).sngPosition Then
                        g_Obj(j).sngValue = 0
                        g_BMS.lngTotalNotes = g_BMS.lngTotalNotes - 1
                    End If
                
                Next j
                
                For j = i + 1 To UBound(g_Obj)
                
                    If .sngPosition <> g_Obj(j).sngPosition Then
                        Exit For
                    ElseIf g_Obj(j).intChannel - 10 = .intChannel - 30 And .sngPosition = g_Obj(j).sngPosition Then
                        g_Obj(j).intChannel = 0
                        g_BMS.lngTotalNotes = g_BMS.lngTotalNotes - 1
                    End If
                
                Next j
                
                For j = i + 1 To UBound(g_Obj)
                
                    If .intChannel Mod 20 = g_Obj(j).intChannel Mod 20 And g_Obj(j).intChannel >= 11 Then
                    
                        .lngHeight = g_Obj(j).sngPosition - .sngPosition
                        g_Obj(j).intChannel = (g_Obj(j).intChannel + 10) Mod 20 + 50
                        g_BMS.lngTotalNotes = g_BMS.lngTotalNotes - 1
                        Exit For
                    
                    End If
                
                Next j
            
            End If
        
        End With
    
    Next i
    
    Exit Sub

Err:
    Call CleanUp(Err.Number, Err.Description, "LoadBMSSort")
End Sub

Private Sub LoadingTitle()

    If timeGetTime() - g_lngPlayStartTime >= 1000 Then
        frmMain.Caption = frmMain.Caption + "."
        g_lngPlayStartTime = timeGetTime()
    End If

End Sub

Public Sub QuickSort(ByVal lngLeft As Long, ByVal lngRight As Long)

    Dim i   As Long
    Dim j   As Long

    If lngLeft >= lngRight Then Exit Sub
    If g_intGameMode = 1 Then Exit Sub
    
    i = lngLeft + 1
    j = lngRight
    
    Do While i <= j
    
        DoEvents
        Do While i <= j
        
            If g_Obj(i).sngPosition > g_Obj(lngLeft).sngPosition Then
                Exit Do
            End If
            
            i = i + 1
        Loop
        
        Do While i <= j
        
            If g_Obj(j).sngPosition < g_Obj(lngLeft).sngPosition Then
                Exit Do
            End If
            
            j = j - 1
        
        Loop

        If i >= j Then Exit Do

        Call SwapObj(g_Obj(j), g_Obj(i))

        i = i + 1
        j = j - 1
    
    Loop

    Call SwapObj(g_Obj(j), g_Obj(lngLeft))
    Call QuickSort(lngLeft, j - 1)
    Call QuickSort(j + 1, lngRight)

End Sub

Private Sub LoadBMSObject(ByVal strRet As String)
On Error GoTo Err:

    Dim i           As Long
    Dim intMeasure  As Integer
    Dim intChannel  As Integer
    Dim strParam    As String
    Dim lngSepaNum  As Long

    intMeasure = Val(Mid$(strRet, 2, 3))
    intChannel = Val(Mid$(strRet, 5, 2))
    strParam = Trim$(strGetParam(strRet))
    
    lngSepaNum = Len(strParam) \ 2
    
    If intChannel = 2 And intMeasure - g_BMS.intStartMeasure >= 0 Then  'ߐύX
    
        If Val(strParam) = 0 Then Exit Sub
        g_Measure(intMeasure - g_BMS.intStartMeasure).sngLen = 192 * g_PlayOption.intDefaultPhase * Val(strParam)
        Exit Sub
    
    End If
    
    For i = 1 To lngSepaNum
    
        If Mid$(strParam, i * 2 - 1, 2) <> "00" Then
        
            With g_Obj(UBound(g_Obj))
                .blnFlag = True
                If intMeasure - g_BMS.intStartMeasure >= 0 Then
                    .intMeasure = intMeasure - g_BMS.intStartMeasure
                Else
                    Exit Sub
                End If
                .sngPosition = i - 1
                .lngHeight = lngSepaNum
                .intChannel = intChConv(intChannel)
            
                Select Case intChannel
                
                    Case 1, 4, 7, 8, 9 'BGM,BGA,Layer,gBPM,XgbvV[PX Poor(Ch6)
                    
                        .sngValue = lngNumConv(Mid$(strParam, i * 2 - 1, 2))
                    
                    Case 3 'BPM
                    
                        .sngValue = Val("&H" + Mid$(strParam, i * 2 - 1, 2))
                    
                    Case 11 To 16, 18, 19, 21 To 26, 28, 29, 51 To 56, 58, 59, 61 To 66, 68, 69 'L[
                    
                        .sngValue = lngNumConv(Mid$(strParam, i * 2 - 1, 2))
                        g_BMS.lngTotalNotes = g_BMS.lngTotalNotes + 1
                    
                    Case Else
                    
                        Exit Sub
                
                End Select
            
            End With
            
            ReDim Preserve g_Obj(UBound(g_Obj) + 1)
        
        End If
            
    Next i
            
    Exit Sub

Err:
    Call CleanUp(Err.Number, Err.Description, "LoadBMSObject")
End Sub

Private Sub SwapObj(ByRef Obj1 As m_udtObj, ByRef Obj2 As m_udtObj)

    Dim dummyObj    As m_udtObj
    
    With dummyObj
        .blnFlag = Obj1.blnFlag
        .intChannel = Obj1.intChannel
        .sngValue = Obj1.sngValue
        .intMeasure = Obj1.intMeasure
        .sngPosition = Obj1.sngPosition
        .lngHeight = Obj1.lngHeight
    End With

    With Obj1
        .blnFlag = Obj2.blnFlag
        .intChannel = Obj2.intChannel
        .sngValue = Obj2.sngValue
        .intMeasure = Obj2.intMeasure
        .sngPosition = Obj2.sngPosition
        .lngHeight = Obj2.lngHeight
    End With

    With Obj2
        .blnFlag = dummyObj.blnFlag
        .intChannel = dummyObj.intChannel
        .sngValue = dummyObj.sngValue
        .intMeasure = dummyObj.intMeasure
        .sngPosition = dummyObj.sngPosition
        .lngHeight = dummyObj.lngHeight
    End With

End Sub

Private Function strGetParam(ByVal strRet As String) As String
    
    Dim strArray()  As String
    
    strArray() = Split(strRet, ":")

    If UBound(strArray) > 0 Then
        strGetParam = strArray(UBound(strArray))
    Else
        strGetParam = ""
    End If

End Function
